//  ,     QMS17, 
//   
//     .


#include "qmx.h"
//#include "qmx_core.h"
#include <shellapi.h>
#include <stdio.h>
#include <conio.h> 


HANDLE SD;                              //  
WORD Gain, QMS15Table[16], Data1, Data2, Channel;
QMX_CC_F CC_Adc;
QMX_CONFIG CFG;                         //  

static unsigned int DataPtr, DataPtrOld, CurrentPtr, LengthDataBuf;
static unsigned short int *Data;
static unsigned long long int QMS_data[8][32], QMS_iter[8][32], time, temp;


void CheckErr(void);
void quit(void);
void DisplayData(void);


void main(int argc, char* argv[])
{
	char s_wrk[64];
	int mod, ch;;

	printf("Please wait....\r");
	
	//  
	ShellExecuteW(NULL, TEXT("open"), TEXT("qmbox_ds.exe"), TEXT("-p3"), NULL, SW_SHOWNORMAL);
	Sleep(500);

	//   
	SD = 0;
	SD=QMX_CircBufAttach(0);
	if (SD == NULL) {
		printf("ERROR: No QMBox found.");
		quit(); 
	}

	//  
	QMX_InitModules(SD, QMX_LOG_NONE, NULL);
	CheckErr();


	//   QMX_Prepare -   
	// ..     
	QMX_MOD_SetActive(SD, 0, QMX_ON);
	QMX_Prepare(SD, 100, &CFG);
	CheckErr();
	QMX_MOD_SetActive(SD, 0, QMX_OFF);
	
	// ,      -  QMS17
	strncpy_s (s_wrk, CFG.ModName[0], 5); s_wrk[5] = 0;
	if (!_stricmp(s_wrk, "QMS17"))	printf("Module name OK\n");
	else{ printf("Module Name error\n");	quit();	}


	//  
	Gain = QMX_QMS17_GAIN_1;

	//  .    
	QMX_QMS17_ReadCC(SD, 0, Gain, &CC_Adc);

	//   ,   4  - 0, 1, 2  3
	QMX_QMS17_SetTable(SD, 0, 0xF, Gain);



	//     1 M (  16-  - 2 )
	QMX_QMS17_SetInputRate(SD, 0, 2000000.0, NULL);
	CheckErr();

	//    
	QMX_MOD_SetActive(SD, 0, QMX_ON);
	QMX_Prepare(SD, 100, &CFG);
	CheckErr();
	
	LengthDataBuf = *CFG.CBInput.buf_size;						//    ,  
	Data = (unsigned short int*)CFG.CBInput.buf_start;			//      ,
																//  
	DataPtrOld = 0;
	time = 0;

	//   
	QMX_Start(SD);
	CheckErr();

	while (!_kbhit()){											//    
																// (   )

		DataPtr = *CFG.CBInput.buf_ptr;							//     
																//   						
		for (CurrentPtr = DataPtrOld; CurrentPtr != DataPtr; CurrentPtr += 2) { //      
			
			if(CurrentPtr >= *CFG.CBInput.buf_size)				// , 
				CurrentPtr = 0;									//    
			if ((!CurrentPtr)&&(!DataPtr))break;				//     

			mod = (Data[CurrentPtr] >> 5) & 0x07;				//   () 16-      
			ch  = Data[CurrentPtr]  & 0x1f;						//     ( 5- )   (. 3- ).

	
			QMS_data[mod][ch] += Data[CurrentPtr+1];
																//   () 16-     
																//          
																// (  ).
																//     i*2   16   i-  
																//    i*2 + 1 -  2  i-  


																//        ([][])
																//   .      
																//      ,    
																//    .
			QMS_iter[mod][ch]++;								//       
	
		}

		DataPtrOld = DataPtr;						//      
													//  

		time++;										//   100  
		if (time >=5){								//     0.5 ,
			DisplayData();							//    
			time = 0;								//    100  
		}

		Sleep(50);									//         100 
													//        Sleep  
													//        

 }

	quit();											//   
}



//   
void quit(void){
	
	printf("\n\n Please wait....\r");
	QMX_Stop(SD, QMX_STOP_ALL);			//  
	QMX_MOD_SetStartMode(SD, 0xFF, QMX_START_MODE_MANUAL); 									

	QMX_CircBufDetach(SD);              //    USB
										//  
	ShellExecute(NULL, TEXT("open"), TEXT("qmbox_ds.exe"), TEXT("-s0"), NULL, SW_SHOWNORMAL);
	printf("\n\n");
	ExitProcess(0);
}


//   
void CheckErr(void) {
char tmp_str[1024];

if (QMX_GetLastError(SD, tmp_str, sizeof(tmp_str))==QMX_OK){ return;}
else  {	printf("%s\n", tmp_str);	quit();}
}



//  
void DisplayData(void){

	double d_wrk, d_result[16];
	unsigned int i_result[16], i, k = 0;

	//   
	for (i = 0; i < 4; i++) d_result[i] = ((double)(QMS_data[0][i*2] * 4 + QMS_data[0][i*2 + 1]) / (double)QMS_iter[0][i*2]) * CC_Adc.Scale + CC_Adc.Offset;

	// 
	for (i = 0; i < 3; i++) printf("%2.6f  ", d_result[i]);	
	printf("%2.6f  \r", d_result[i]);	


	//       :
	for (i = 0; i < 32; i++)	{QMS_data[0][i] = 0; QMS_iter[0][i] = 0; }

}


